;**************************************************************
;     Editor
;**************************************************************
;   Copyright (c) 2010 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



Global Editor.Editor



Declare.i OpenActEditor()
Declare.i OpenChallangeProperties()
Declare.i OpenSceneProperties(*Scene.Scene)



IncludeFile "Editor\Tools.pb"

IncludeFile "Editor\Main.pb"
IncludeFile "Editor\Interface.pb"
IncludeFile "Editor\Display.pb"
IncludeFile "Editor\Scene.pb"
IncludeFile "Editor\Tile.pb"
IncludeFile "Editor\Object.pb"
IncludeFile "Editor\Selection.pb"

IncludeFile "Editor\TilesetViewer.pb"
IncludeFile "Editor\SceneViewer.pb"
IncludeFile "Editor\ObjectViewer.pb"
IncludeFile "Editor\BackgroundViewer.pb"
IncludeFile "Editor\ChallangeViewer.pb"

IncludeFile "Editor\Camera.pb"
IncludeFile "Editor\Save&Load.pb"

IncludeFile "Editor\ChallangeProperties.pb"
IncludeFile "Editor\SceneProperties.pb"
IncludeFile "Editor\ActEditor.pb"
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 32
; FirstLine = 8
; EnableXP