Global *ChallangeViewer_Challange.Challange



Procedure.i UpdateChallangeViewerChallanges(*Folder.Entry, Level.i = 0)
  Protected *Challange.Challange, *Entry.Entry, *Item.QueueItem
  
  *Item = *Folder\Entries\First
  While *Item
    *Entry     = *Item\Memory
    
    Select *Entry\Type
      Case #Entry_File
        *Challange = *Entry\Memory
        
        AddGadgetItem(#CV_Challanges, -1, *Challange\Name, 0, Level)
        SetGadgetItemData(#CV_Challanges, CountGadgetItems(#CV_Challanges) - 1, *Challange)
      Case #Entry_Folder
        AddGadgetItem(#CV_Challanges, -1, *Entry\Name, 0, Level)
        UpdateChallangeViewerChallanges(*Entry, Level + 1)
    EndSelect
    
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i SelectChallangeViewerChallange(*Challange.Challange)
  *ChallangeViewer_Challange = *Challange
  
  SetGadgetText(#CV_Author, "Author: " + *Challange\Author)
  SetGadgetText(#CV_Comment, *Challange\Comment)
EndProcedure
Procedure.i CloseChallangeViewer()
  CloseWindow(#CVWindow)
EndProcedure
Procedure.i OpenChallangeViewer()
  Protected Event.i, Window.i, Gadget.i, Type.i
  Protected *Memory, Index.i
  
  OpenWindow(#CVWindow, 259, 175, 400, 500, "Challanges", #PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_TitleBar)
    TreeGadget(#CV_Challanges, 10, 50, 380, 300, #PB_Tree_AlwaysShowSelection)
    TextGadget(#CV_Author, 10, 360, 380, 20, "Author:")
    EditorGadget(#CV_Comment, 20, 400, 360, 80)
    Frame3DGadget(#CV_CommentFrame, 10, 380, 380, 110, "Comment")
    ButtonGadget(#CV_Select, 10, 10, 50, 30, "Select")
    ButtonGadget(#CV_Cancel, 340, 10, 50, 30, "Cancel")
  
  UpdateChallangeViewerChallanges(*ChallangeFolder)
  
  Repeat
    Event  = WaitWindowEvent()
    Window = EventWindow()
    Gadget = EventGadget()
    Type   = EventType()
    
    If Window = #CVWindow
      Select Event
        Case #PB_Event_Gadget
          Select Gadget
            Case #CV_Challanges
              If Type = #PB_EventType_LeftClick
                Index = GetGadgetState(#CV_Challanges)
                If Index <> #None
                  *Memory = GetGadgetItemData(#CV_Challanges, Index)
                  If *Memory
                    SelectChallangeViewerChallange(*Memory)
                  EndIf
                EndIf
              ElseIf Type = #PB_EventType_LeftDoubleClick
                Editor\LeftClickAllowed = #False
                If *ChallangeViewer_Challange
                  Break
                EndIf
              EndIf
            Case #CV_Select
              If *ChallangeViewer_Challange
                Break
              EndIf
            Case #CV_Cancel
              CloseChallangeViewer()
              ProcedureReturn #Null
          EndSelect
        Case #PB_Event_CloseWindow
          CloseChallangeViewer()
          ProcedureReturn #Null
      EndSelect
    EndIf
  ForEver
  
  CloseChallangeViewer()
  ProcedureReturn *ChallangeViewer_Challange
EndProcedure
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 67
; FirstLine = 47
; Folding = -
; EnableXP