IncludeFile "..\Import.pbi"



ProcedureDLL.i GM_Build()
  DataSection
    Entries:
      GM_Folder("Score")
        GM_File("AddScore")
        GM_End()
      GM_Folder("Lives & Energy")
        GM_File("AddEnergy")
        GM_File("FillEnergy")
        GM_File("AddLife")
        GM_File("HitPlayer")
        GM_End()
      GM_End()
  EndDataSection
  
  ProcedureReturn ?Entries
EndProcedure



ProcedureDLL.i Effect_AddScore(*Effect.GM_Effect, Event.i, *Parameter)
  *EditorEffect = *Parameter
  
  Select Event
    Case #GM_Effect_Call
      GM_AddScore(*Effect\Memory)
    Case #GM_Effect_EditorSave
      GM_SaveInteger(*EditorEffect\Memory)
    Case #GM_Effect_EditorLoad
      *EditorEffect\Memory = GM_LoadInteger()
    Case #GM_Effect_Load
      *Effect\Memory = GM_LoadInteger()
    Case #GM_Effect_Edit
      *EditorEffect\Memory = GM_EditInteger("Add Score", "Score to add:", *EditorEffect\Memory, 1, 1000000)
    Case #GM_Effect_Name
      ProcedureReturn @"Add Score"
    Case #GM_Effect_Text
      String = "Add " + Form(*EditorEffect\Memory, "point", "points")
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

ProcedureDLL.i Effect_AddEnergy(*Effect.GM_Effect, Event.i, *Parameter)
  *EditorEffect = *Parameter
  
  Select Event
    Case #GM_Effect_Call
      *GM_Player\Energy + *Effect\Memory
    Case #GM_Effect_EditorSave
      GM_SaveInteger(*EditorEffect\Memory)
    Case #GM_Effect_EditorLoad
      *EditorEffect\Memory = GM_LoadInteger()
    Case #GM_Effect_Load
      *Effect\Memory = GM_LoadInteger()
    Case #GM_Effect_Edit
      *EditorEffect\Memory = GM_EditInteger("Add Energy", "Energy to add:", *EditorEffect\Memory, 1, 10)
    Case #GM_Effect_Name
      ProcedureReturn @"Add Energy"
    Case #GM_Effect_Text
      String = "Add " + Form(*EditorEffect\Memory, "energy point", "energy points")
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Effect_FillEnergy(*Effect.GM_Effect, Event.i, *Parameter)
  *EditorEffect = *Parameter
  
  Select Event
    Case #GM_Effect_Call
      *GM_Player\Energy = *GM_Player\MaxEnergy
    Case #GM_Effect_Name
      ProcedureReturn @"Fill Energy"
    Case #GM_Effect_Text
      ProcedureReturn @"Fill energy"
  EndSelect
EndProcedure
ProcedureDLL.i Effect_AddLife(*Effect.GM_Effect, Event.i, *Parameter)
  *EditorEffect = *Parameter
  
  Select Event
    Case #GM_Effect_Call
      *GM_Player\Lives + *Effect\Memory
    Case #GM_Effect_EditorSave
      GM_SaveInteger(*EditorEffect\Memory)
    Case #GM_Effect_EditorLoad
      *EditorEffect\Memory = GM_LoadInteger()
    Case #GM_Effect_Load
      *Effect\Memory = GM_LoadInteger()
    Case #GM_Effect_Edit
      *EditorEffect\Memory = GM_EditInteger("Add Life", "Lives to add:", *EditorEffect\Memory, 1, 100)
    Case #GM_Effect_Name
      ProcedureReturn @"Add Life"
    Case #GM_Effect_Text
      String = "Add " + Form(*EditorEffect\Memory, "life", "lives")
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Effect_HitPlayer(*Effect.GM_Effect, Event.i, *Parameter)
  *EditorEffect = *Parameter
  
  Select Event
    Case #GM_Effect_Call
      GM_HitPlayer(*Effect\Memory)
    Case #GM_Effect_EditorSave
      GM_SaveInteger(*EditorEffect\Memory)
    Case #GM_Effect_EditorLoad
      *EditorEffect\Memory = GM_LoadInteger()
    Case #GM_Effect_Load
      *Effect\Memory = GM_LoadInteger()
    Case #GM_Effect_Edit
      *EditorEffect\Memory = GM_EditInteger("Hit Player", "Energy to lose", *EditorEffect\Memory, 1, 10)
    Case #GM_Effect_Name
      ProcedureReturn @"Hit Player"
    Case #GM_Effect_Text
      String = "Lose " + Form(*EditorEffect\Memory, "energy point", "energy points")
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 13
; Folding = --
; EnableXP