IncludeFile "..\Import.pbi"



ProcedureDLL.i GM_Build()
  DataSection
    Entries:
      GM_Folder("Score")
        GM_File("ScoreReached")
        GM_File("MultiplierReached")
        GM_File("Coins")
        GM_End()
      GM_End()
  EndDataSection
  
  ProcedureReturn ?Entries
EndProcedure



ProcedureDLL.i Event_ScoreReached(*Event.GM_Event, Event.i, *Parameter)
  *EditorEvent = *Parameter
  
  Select Event
    Case #GM_Event_Triggered
      If *GM_Player\Score => *Event\Memory
        ProcedureReturn #True
      EndIf
    Case #GM_Event_EditorSave
      GM_SaveInteger(*EditorEvent\Memory)
    Case #GM_Event_EditorLoad
      *EditorEvent\Memory = GM_LoadInteger()
    Case #GM_Event_Load
      *Event\Memory = GM_LoadInteger()
    Case #GM_Event_Edit
      *EditorEvent\Memory = GM_EditInteger("Reach Score", "Score to reach:", *EditorEvent\Memory, 0, 1000000)
    Case #GM_Event_Name
      ProcedureReturn @"Score Reached"
    Case #GM_Event_Text
      String = Form(*EditorEvent\Memory, "point", "points") + " reached"
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Event_MultiplierReached(*Event.GM_Event, Event.i, *Parameter)
  *EditorEvent = *Parameter
  
  Select Event
    Case #GM_Event_Triggered
      If *GM_Player\Multiplier => *Event\Memory
        ProcedureReturn #True
      EndIf
    Case #GM_Event_EditorSave
      GM_SaveInteger(*EditorEvent\Memory)
    Case #GM_Event_EditorLoad
      *EditorEvent\Memory = GM_LoadInteger()
    Case #GM_Event_Load
      *Event\Memory = GM_LoadInteger()
    Case #GM_Event_Edit
      *EditorEvent\Memory = GM_EditInteger("Reach Multiplier", "Multiplier to reach:", *EditorEvent\Memory, 0, 100)
    Case #GM_Event_Name
      ProcedureReturn @"Multiplier Reached"
    Case #GM_Event_Text
      String = "Multiplier " + Str(*EditorEvent\Memory) + "X reached"
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Event_Coins(*Event.GM_Event, Event.i, *Parameter)
  *EditorEvent = *Parameter
  
  Select Event
    Case #GM_Event_Triggered
      If *GM_Player\Coins => *Event\Memory
        ProcedureReturn #True
      EndIf
    Case #GM_Event_EditorSave
      GM_SaveInteger(*EditorEvent\Memory)
    Case #GM_Event_EditorLoad
      *EditorEvent\Memory = GM_LoadInteger()
    Case #GM_Event_Load
      *Event\Memory = GM_LoadInteger()
    Case #GM_Event_Edit
      *EditorEvent\Memory = GM_EditInteger("Coins collected", "Amount of coins to collect:", *EditorEvent\Memory, 0, 100000)
    Case #GM_Event_Name
      ProcedureReturn @"Coins collected"
    Case #GM_Event_Text
      String = Form(*EditorEvent\Memory, "coin", "coins") + " collected"
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 69
; FirstLine = 46
; Folding = -
; EnableXP