;START:
ProcedureDLL.s GM_ActName(*Act.Act)
  ProcedureReturn *Act\Name
EndProcedure
ProcedureDLL.i GM_GetAct(Name.s)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn GetAct(Name)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_GetActByNumber(Number.i)
  ProcedureReturn *IO_Act(Number)
EndProcedure
ProcedureDLL.i GM_UseAct(*Act.Act)
  CompilerIf #Mode = #Mode_Editor
  
  UseAct(*Act)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_ReleaseAct(*Act.Act)
  CompilerIf #Mode = #Mode_Editor
  
  ReleaseAct(*Act)
  
  CompilerEndIf
EndProcedure

ProcedureDLL.i GM_ChangeAct(*Act)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn ChangeAct(*Act)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_AddParallelAct(*Act)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn AddParallelAct(*Act)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_RemoveParallelAct(*Act)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn RemoveParallelAct(*Act)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_EventsRemaining(*Act.Act)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn *Act\Remaining
  
  CompilerEndIf
EndProcedure

ProcedureDLL.i GM_EventAct(*Event.Event)
  ProcedureReturn *Event\Act
EndProcedure
ProcedureDLL.i GM_StopEvent(*Event.Event, Frames.i)
  CompilerIf #Mode = #Mode_Game
  
  *Event\IdleTime = Frames
  
  CompilerEndIf
EndProcedure

ProcedureDLL.i GM_EffectEvent(*Effect.Effect)
  ProcedureReturn *Effect\Event
EndProcedure
ProcedureDLL.i GM_EffectAct(*Effect.Effect)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn *Effect\Event\Act
  
  CompilerEndIf
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 64
; Folding = AQ+
; EnableXP