;START:
ProcedureDLL.i GM_ShowMessage(Title.s, Message.s)
  ProcedureReturn ShowMessage(Title, Message)
EndProcedure
ProcedureDLL.s GM_EditMessage(Title.s, Message.s = "")
  ProcedureReturn EditMessage(Title, Message)
EndProcedure
ProcedureDLL.i GM_EditInteger(Title.s, Text.s, Number.i, Min.i, Max.i)
  ProcedureReturn EditInteger(Title, Text, Number, Min, Max)
EndProcedure
ProcedureDLL.s GM_EditString(Title.s, Text.s, String.s)
  ProcedureReturn EditString(Title, Text, String)
EndProcedure

ProcedureDLL.i GM_Select(*Selection, *Callback, Info.s = "Select")
  CompilerIf #Mode = #Mode_Editor
  
  ProcedureReturn SelectionMode(*Selection, *Callback, Info)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_SelectObjects(*Selection, Info.s = "Select objects")
  CompilerIf #Mode = #Mode_Editor
  
  ProcedureReturn SelectionMode(*Selection, @Selection_Callback_Objects(), Info)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_SelectSingleObject(*Selection, Info.s = "Select object")
  CompilerIf #Mode = #Mode_Editor
  
  ProcedureReturn SelectionMode(*Selection, @Selection_Callback_SingleObject(), Info)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_EditSelection(*Selection, Info.s = "Select fields")
  CompilerIf #Mode = #Mode_Editor
  
  ProcedureReturn SelectionMode(*Selection, @Selection_Callback_None(), Info)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_SelectField(*Selection, Info.s = "Select field")
  CompilerIf #Mode = #Mode_Editor
  
  ProcedureReturn SelectionMode(*Selection, @Selection_Callback_SingleField(), Info)
  
  CompilerEndIf
EndProcedure

ProcedureDLL.i GM_SelectAct(Title.s, Text.s, *DefaultAct = #Null, AllowNoAct.i = #False, AllowNewAct.i = #False)
  CompilerIf #Mode = #Mode_Editor
  
  ProcedureReturn SelectAct(Title, Text, *DefaultAct, AllowNoAct, AllowNewAct)
  
  CompilerEndIf
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 53
; Folding = A5
; EnableXP