;START:
ProcedureDLL.i GM_AddScore(Score.i)
  CompilerIf #Mode = #Mode_Game
  
  AddScore(Score)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_AddScoreTM(Score.i, *Object.Object)
  CompilerIf #Mode = #Mode_Game
  
  If Player\Multiplier = 1
    CreateTinyMessage(*Object\X + *Object\Width / 2, *Object\Y + *Object\Height / 2, Str(Score))
  Else
    CreateTinyMessage(*Object\X + *Object\Width / 2, *Object\Y + *Object\Height / 2, Str(Score) + "*" + Str(Player\Multiplier))
  EndIf
  
  AddScore(Score)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_AddScoreNMTM(Score.i, *Object.Object)
  CompilerIf #Mode = #Mode_Game
  
  CreateTinyMessage(*Object\X + *Object\Width / 2, *Object\Y + *Object\Height / 2, Str(Score))
  
  AddScoreNM(Score)
  
  CompilerEndIf
EndProcedure

ProcedureDLL.i GM_EnhanceMultiplier(Times.i, Duration.i = 190)
  CompilerIf #Mode = #Mode_Game
  
  Player\Multiplier            + Times
  Player\MultiplierDuration    = Duration
  Player\MultiplierChangedTime = #Player_MultiplierChangedTime
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_ShowComment(Comment.s, Duration.i = 100)
  CompilerIf #Mode = #Mode_Game
  
  ShowComment(Comment, Duration)
  
  CompilerEndIf
EndProcedure

ProcedureDLL.i GM_AddCoin()
  CompilerIf #Mode = #Mode_Game
  
  AddItem(*CoinItem)
  CallSpecialEventEffects(*CurrentAct, #SpecialEvent_CoinCollected)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_AddSuperCoin()
  CompilerIf #Mode = #Mode_Game
  
  AddItem(*CoinItem)
  AddItem(*SuperCoinItem)
  CallSpecialEventEffects(*CurrentAct, #SpecialEvent_CoinCollected)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_CountCoin()
  CompilerIf #Mode = #Mode_Game
  
  *CoinItem\MaxCount + 1
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_CountSuperCoin()
  CompilerIf #Mode = #Mode_Game
  
  *CoinItem\MaxCount      + 1
  *SuperCoinItem\MaxCount + 1
  
  CompilerEndIf
EndProcedure
; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 72
; Folding = g-
; EnableXP