IncludeFile "..\Import.pbi"
IncludeFile "Templates\Box.pb"



EnableExplicit



#CoinRadius        = 6
#CoinOuterRadius   = #GM_FieldSize/2 - #CoinRadius
#CoinRotationSpeed = 5
#Coins             = 5



Structure CoinParameter
  Initialised.i
  Index.i
  Value.i
  Name.s
EndStructure



ProcedureDLL.i GM_Load()
  Global Dim Coin_Frameset.i(#Coins)
  Global CollectedCoinFrameset.i
EndProcedure
ProcedureDLL.i GM_Build()
  DataSection
    Entries:
      GM_Folder("Coins")
        GM_Folder("Visible")
          GM_File("Coin1")
          GM_File("Coin2")
          GM_File("Coin3")
          GM_File("Coin4")
          GM_File("Coin5")
          GM_File("Coin6")
          GM_End()
        GM_Folder("Invisible")
          GM_File("ICoin1")
          GM_File("ICoin2")
          GM_File("ICoin3")
          GM_File("ICoin4")
          GM_File("ICoin5")
          GM_File("ICoin6")
          GM_End()
        GM_Folder("Boxes")
          GM_File("Box1")
          GM_File("Box2")
          GM_File("Box3")
          GM_End()
        GM_Folder("Hit Blocks")
          GM_File("HitBlock1")
          GM_File("HitBlock2")
          GM_File("HitBlock3")
          GM_File("HitBlock4")
          GM_File("HitBlock5")
          GM_File("HitBlock6")
          GM_End()
          GM_File("LightCoin")
        GM_End()
      GM_End()
  EndDataSection
  
  ProcedureReturn ?Entries
EndProcedure



Procedure.i LoadCoin(Index.i)
  If Not Coin_Frameset(Index)
    Coin_Frameset(Index) = GM_LoadAnimationFrameset("Coin\Coin" + Str(Index + 1), #GM_FieldSize, #GM_FieldSize)
  EndIf
  If Not CollectedCoinFrameset
    CollectedCoinFrameset = GM_LoadAnimationFrameset("Coin\Collected", #GM_FieldSize, #GM_FieldSize)
  EndIf
EndProcedure
Procedure.i IsCoinCollected(*Coin.GM_Object)
  If *Coin\Memory
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure



IncludeFile "Coins\Coin.pb"
IncludeFile "Coins\InvisibleCoin.pb"
IncludeFile "Coins\Boxes.pb"
IncludeFile "Coins\HitBlock.pb"
IncludeFile "Coins\LightCoin.pb"

; IDE Options = PureBasic 4.51 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 60
; FirstLine = 26
; Folding = +
; Executable = ..\..\Objects\Coin.dll