Global LightCoin_Frameset.i

ProcedureDLL.i Obj_LightCoin(*Object.GM_Object, Event.i, *Parameter)
  Select Event
    Case #GM_Object_Display
      If *Object\Memory
        If *Object\Memory < 20
          If *Object\Memory % 7 < 4
            GM_DisplayAnimation(*Object\Animation, *Object\X - #CoinOuterRadius, *Object\Y - #CoinOuterRadius, *Object\Transparency)
          Else
            GM_DisplayFramesetFrame(CollectedCoinFrameset, GM_AnimationFrame(*Object\Animation), 0, *Object\X - #CoinOuterRadius, *Object\Y - #CoinOuterRadius, *Object\Transparency)
          EndIf
        EndIf
      Else
        GM_DisplayAnimation(*Object\Animation, *Object\X - #CoinOuterRadius, *Object\Y - #CoinOuterRadius, *Object\Transparency)
      EndIf
    Case #GM_Object_Frame
      If *Object\Memory
        If *Object\Memory < 20
          ; Mnze ausblenden und nach oben fliegen lassen (wenn gesammelt):
          *Object\Transparency = 255 - (Pow(Pow(255, 1.0/20), *Object\Memory) - 1)
          *Object\Y - 2.5
          
          *Object\Memory + 1
          
          ; Animation abspielen lassen:
          If GM_PlayAnimation(*Object\Animation)
            ; Es wurde auf ein neues Frame gewechselt:
            GM_SetAnimationDuration(*Object\Animation, 0) ;Dauer fr den neuen Frame festlegen
          EndIf
        Else
          ; Mnze entgltig aus dem Spiel entfernen:
          ProcedureReturn #GM_Object_DoDelete
        EndIf
      Else
        ; Animation abspielen lassen:
        If GM_PlayAnimation(*Object\Animation)
          ; Es wurde auf ein neues Frame gewechselt (Duration = 0):
          GM_SetAnimationDuration(*Object\Animation, #CoinRotationSpeed) ;Dauer fr den neuen Frame festlegen
        EndIf
      EndIf
    Case #GM_Object_Collision
      If Not *Object\Memory ;Noch nicht gesammelt?
        GM_EmitTinyFlash(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2)
        *Object\Memory = 1 ;Auf "gesammelt" setzen
      EndIf
    Case #GM_Object_Delete
      GM_FreeAnimation(*Object\Animation)
      
    Case #GM_Object_Initialize
      ; Passend verschieben:
      *Object\X      + #CoinOuterRadius
      *Object\Y      + #CoinOuterRadius
      ; Breite und Hhe an die Mae einer Mnze anpassen:
      *Object\Width  = #CoinRadius*2
      *Object\Height = #CoinRadius*2
      
      *Object\Animation = GM_CreateAnimation(LightCoin_Frameset)
      GM_SetNextAnimationFrame(*Object\Animation, Random(3), Random(#CoinRotationSpeed))
    Case #GM_Object_Load
      ; Position der Mnze laden:
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      LightCoin_Frameset = GM_LoadAnimationFrameset("Coin\LightCoin", #GM_FieldSize, #GM_FieldSize)
      If Not CollectedCoinFrameset
        CollectedCoinFrameset = GM_LoadAnimationFrameset("Coin\Collected", #GM_FieldSize, #GM_FieldSize)
      EndIf
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
      
    Case #GM_Object_ViewSprite
      ; Name des Anzeige-Sprites fr den Editor zurckgeben:
      ReturnString("Coin\LightCoin")
    Case #GM_Object_ViewRegion
      ReturnViewRegion(0, 0, 1, 1)
    Case #GM_Object_PreferedLayer
      ; Bevorzugter Layer:
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      ; berprfen, ob der gewhlte Layer geeignet ist:
      If *Parameter = #GM_Layer_StaticObject
        ; Nicht geeignet:
        ProcedureReturn #False
      Else
        ; Geeignet:
        ProcedureReturn #True
      EndIf
    Case #GM_Object_Name
      ; Name des Objekts zurckgeben:
      ProcedureReturn @"Light Coin"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 43
; FirstLine = 24
; Folding = -
; EnableXP