IncludeFile "..\Import.pbi"
IncludeFile "Templates\Animation.pb"



ProcedureDLL.i GM_Build()
  DataSection
    Entries:
      GM_Folder("Scenery")
        GM_Folder("Lights")
          GM_File("Light1")
          GM_File("FlickeringLight1")
          GM_End()
        GM_End()
      GM_End()
  EndDataSection
  
  ProcedureReturn ?Entries
EndProcedure



Global Light1.i



Procedure.i Light1_Callback(*Object.GM_Object)
  GM_SetAnimationFrame(*Object\Animation, 0)
EndProcedure
ProcedureDLL.i Obj_Light1(*Object.GM_Object, Event.i, *Parameter)
  Global Obj_Light1.AnimationParameter
  
  With Obj_Light1
    If Not \Initialized
      \Name        = "Light 1"
      \File        = "Lights\Light1"
      \FrameWidth  = #GM_FieldSize
      \FrameHeight = #GM_FieldSize
      \Callback    = @Light1_Callback()
      \Frameset    = @Light1
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn AnimationTemplate(*Object, Event, *Parameter, @Obj_Light1)
EndProcedure

Procedure.i FlickeringLight1_Callback(*Object.GM_Object)
  Select *Object\Memory
    Case 0
      GM_SetAnimationDuration(*Object\Animation, 60 + Random(400))
    Case 1, 2, 3
      GM_SetAnimationDuration(*Object\Animation, 2 + Random(6))
    Case 4
      If Random(4) = 0
        GM_SetAnimationDuration(*Object\Animation, 10 + Random(25))
        *Object\Memory = 4
      Else
        GM_SetAnimationDuration(*Object\Animation, 220 + Random(400))
        *Object\Memory = 0
      EndIf
    Case 5
      GM_SetAnimationDuration(*Object\Animation, 380 + Random(800))
    Case 6, 7, 8, 9, 10, 11
      GM_SetAnimationDuration(*Object\Animation, 3 + Random(5))
    Case 12
      GM_SetAnimationDuration(*Object\Animation, 30 + Random(100))
      *Object\Memory = 0
  EndSelect
  
  *Object\Memory + 1
EndProcedure
ProcedureDLL.i Obj_FlickeringLight1(*Object.GM_Object, Event.i, *Parameter)
  Global Obj_FlickeringLight1.AnimationParameter
  
  With Obj_FlickeringLight1
    If Not \Initialized
      \Name        = "Flickering Light 1"
      \File        = "Lights\Light1"
      \FrameWidth  = #GM_FieldSize
      \FrameHeight = #GM_FieldSize
      \Callback    = @FlickeringLight1_Callback()
      \Frameset    = @Light1
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn AnimationTemplate(*Object, Event, *Parameter, @Obj_FlickeringLight1)
EndProcedure
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 60
; FirstLine = 45
; Folding = -
; EnableXP