#JumpSupporter_OuterWidth  = 5
#JumpSupporter_OuterHeight = 2

Global JumpSupporter_Frameset.i

ProcedureDLL.i Obj_JumpSupporter(*Object.GM_Object, Event.i, *Parameter)
  Static Angle.i
  
  Select Event
    Case #GM_Object_Display
      If *Object\Memory
        GM_BlendingMode(5, 2)
        GM_DisplayFramesetFrame(JumpSupporter_Frameset, 1, 0, *Object\X - #JumpSupporter_OuterWidth, *Object\Y - #JumpSupporter_OuterHeight)
        GM_BlendingMode(5, 6)
      Else
        GM_DisplayFramesetFrame(JumpSupporter_Frameset, 0, 0, *Object\X - #JumpSupporter_OuterWidth, *Object\Y - #JumpSupporter_OuterHeight)
      EndIf
    Case #GM_Object_Frame
      If *Object\Memory
        *Object\Memory - 1
      EndIf
    Case #GM_Object_Collision
      If Not *Object\Memory And *GM_Player\KeyPressed[#GM_Player_Key_Jump]
        *GM_Player\MoveY = -5
        *Object\Memory   = 10
        
        For Angle = 0 To 360 - 30 Step 30
          GM_EmitGlitter(*Object\X + *Object\Width/2 + Cos(Radian(Angle)) * 14.0, *Object\Y + *Object\Height/2 + Sin(Radian(Angle)) * 14.0)
        Next
      EndIf
    
    Case #GM_Object_Initialize
      *Object\X + #JumpSupporter_OuterWidth
      *Object\Y + #JumpSupporter_OuterHeight
      
      *Object\Width  = #GM_FieldSize - #JumpSupporter_OuterWidth*2
      *Object\Height = #GM_FieldSize - #JumpSupporter_OuterHeight*2
      
      *Object\Memory = 0
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not JumpSupporter_Frameset
        JumpSupporter_Frameset = GM_LoadAnimationFrameset("System\JumpSupporter", #GM_FieldSize, #GM_FieldSize)
      EndIf
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_BackgroundObject2
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_BackgroundObject2
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @"System\JumpSupporter"
    Case #GM_Object_ViewRegion
      ReturnViewRegion(0, 0, 1, 1)
    Case #GM_Object_Name
      ProcedureReturn @"Jump Supporter"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 28
; Folding = -
; EnableXP