Global WaitingStart.i

Procedure.i OpenLoadingScreen(ClearScreen.i = #False)
  Protected Sprite.i
  
  Sprite = LoadSprite(#PB_Any, GetFile("Graphics\Menu\Loading.bmp"))
  If Not Sprite
    MessageRequester("Error", "Can not load " + #Q + "Graphics\Menu\Loading.bmp" + #Q + ".", #MB_ICONERROR)
    End
  EndIf
  
  If ClearScreen
    ClearScreen(#Black)
  EndIf
  
  DisplaySprite(Sprite, #ScreenWidth/2 - SpriteWidth(Sprite)/2, #ScreenHeight/2 - SpriteHeight(Sprite)/2)
  FlipBuffers()
  
  FreeSprite(Sprite)
  
  WaitingStart = ElapsedMilliseconds()
EndProcedure
Procedure.i CloseLoadingScreen()
  If ElapsedMilliseconds() - WaitingStart < 1250
    Delay(1250 - (ElapsedMilliseconds() - WaitingStart))
  EndIf
EndProcedure
Procedure.i OpenSavingScreen(ClearScreen.i = #False)
  Protected Sprite.i
  
  Sprite = LoadSprite(#PB_Any, "Graphics\Menu\Saving.bmp")
  If Not Sprite
    MessageRequester("Error", "Can not load " + #Q + "Graphics\Menu\Saving.bmp" + #Q + ".", #MB_ICONERROR)
    End
  EndIf
  
  If ClearScreen
    ClearScreen(#Black)
  EndIf
  
  DisplaySprite(Sprite, #ScreenWidth/2 - SpriteWidth(Sprite)/2, #ScreenHeight/2 - SpriteHeight(Sprite)/2)
  FlipBuffers()
  
  FreeSprite(Sprite)
  
  WaitingStart = ElapsedMilliseconds()
EndProcedure
Procedure.i CloseSavingScreen()
  If ElapsedMilliseconds() - WaitingStart < 250
    Delay(250 - (ElapsedMilliseconds() - WaitingStart))
  EndIf
EndProcedure
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 30
; Folding = -
; EnableXP