;START:
ProcedureDLL.i GM_SaveInteger(Integer.i)
  WriteInteger(IO_OutputFile, Integer)
EndProcedure
ProcedureDLL.i GM_LoadInteger()
  ProcedureReturn ReadInteger(IO_InputFile)
EndProcedure
ProcedureDLL.i GM_SaveFloat(Float.f)
  WriteFloat(IO_OutputFile, Float)
EndProcedure
ProcedureDLL.f GM_LoadFloat()
  ProcedureReturn ReadFloat(IO_InputFile)
EndProcedure
ProcedureDLL.i GM_SaveText(Text.s)
  WriteNTString(IO_OutputFile, Text)
EndProcedure
ProcedureDLL.s GM_LoadText()
  ProcedureReturn ReadNTString(IO_InputFile)
EndProcedure

ProcedureDLL.i GM_SaveFieldPosition(X.i, Y.i)
  WriteCharacter(IO_OutputFile, X)
  WriteCharacter(IO_OutputFile, Y)
EndProcedure
ProcedureDLL.i GM_LoadFieldPosition(*X.Integer, *Y.Integer)
  *X\i = ReadCharacter(IO_InputFile) + IO_X
  *Y\i = ReadCharacter(IO_InputFile) + IO_Y
EndProcedure
ProcedureDLL.i GM_LoadPixelPosition(*X.Float, *Y.Float)
  *X\f = (ReadCharacter(IO_InputFile) + IO_X) * #FieldSize
  *Y\f = (ReadCharacter(IO_InputFile) + IO_Y) * #FieldSize
EndProcedure

ProcedureDLL.i GM_SaveObjectAction(*Action.ObjectAction)
  CompilerIf #Mode = #Mode_Editor
  
  ProcedureReturn WriteObjectAction(*Action)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_LoadObjectAction()
  ProcedureReturn ReadObjectAction()
EndProcedure

ProcedureDLL.i GM_SaveActNumber(*Act.Act)
  CompilerIf #Mode = #Mode_Editor
  
  WriteInteger(IO_OutputFile, *Act\Number)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_LoadActNumber()
  ProcedureReturn ReadInteger(IO_InputFile)
EndProcedure

ProcedureDLL.i GM_SaveSelection(*Selection)
  CompilerIf #Mode = #Mode_Editor
  
  WriteLayerlessSelection(*Selection)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_LoadSelection(*Selection = #Null)
  CompilerSelect #Mode
    CompilerCase #Mode_Editor
  
  ProcedureReturn ReadLayerlessSelection(*Selection)
  
    CompilerCase #Mode_Game
  
  ProcedureReturn ReadSelection()
  
  CompilerEndSelect
EndProcedure
ProcedureDLL.i GM_SaveObjectSelection(*Selection)
  CompilerIf #Mode = #Mode_Editor
  
  WriteObjectSelection(*Selection)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_LoadObjectSelection(*Selection = #Null)
  CompilerSelect #Mode
    CompilerCase #Mode_Game
  
  ProcedureReturn ReadObjectSelection()
  
    CompilerCase #Mode_Editor
    
  ProcedureReturn ReadObjectSelection(*Selection)
  
  CompilerEndSelect
EndProcedure

ProcedureDLL.i GM_SaveGame(X.i, Y.i, *Scene.Scene = #Null)
  CompilerIf #Mode = #Mode_Game
  
  If *Scene
    Player\LastCheckpointScene = *Scene
  Else
    Player\LastCheckpointScene = Player\Scene
  EndIf
  Player\LastCheckpointX = X
  Player\LastCheckpointY = Y
  
  ProcedureReturn SaveGame()
  
  CompilerEndIf
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 66
; Folding = AAE-
; EnableXP