;START:
ProcedureDLL.i GM_Player()
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn @Player
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_AddEnergy(Energy.i)
  CompilerIf #Mode = #Mode_Game
  
  Player\Energy + Max(Energy, Player\MaxEnergy)
  ProcedureReturn Player\Energy
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_FillEnergy()
  CompilerIf #Mode = #Mode_Game
  
  Player\Energy = Player\MaxEnergy
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_AddLife()
  CompilerIf #Mode = #Mode_Game
  
  Player\Lives + 1
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_HitPlayer(Energy.i)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn HitPlayer(Energy)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_LoseLife()
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn LoseLife()
  
  CompilerEndIf
EndProcedure

ProcedureDLL.i GM_ChangePlayerAction(Action.i)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn ChangePlayerAction(Action)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_LocatePlayer(X.i, Y.i, *Scene = #Null)
  CompilerIf #Mode = #Mode_Game
  
  If Not *Scene
    *Scene = Player\Scene
  EndIf
  
  Player\SceneToLocate  = *Scene
  Player\FieldXToLocate = X
  Player\FieldYToLocate = Y
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_SetPlayerY(Y.f)
  CompilerIf #Mode = #Mode_Game
  
  Player\Y = Y
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_SetPlayerMoveY(Speed.f)
  CompilerIf #Mode = #Mode_Game
  
  Player\MoveY = Speed
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_ExaminePlayerCollisions()
  CompilerIf #Mode = #Mode_Game
  
  If Not FieldCollision(1, 0)
    FieldCollision(-1, 0)
  EndIf
  If Not FieldCollision(0, 1)
    If Not FieldCollision(1, 1)
      FieldCollision(-1, 1)
    EndIf
  EndIf
  If Not FieldCollision(0, -1)
    If Not FieldCollision(1, -1)
      FieldCollision(-1, -1)
    EndIf
  EndIf
  
  CompilerEndIf
EndProcedure

ProcedureDLL.f GM_DistanceToPlayer(X.f, Y.f)
  CompilerIf #Mode = #Mode_Game
  
  Protected DX.f, DY.f
  
  DX = X - (Player\X + Player\Width/2)
  DY = Y - (Player\Y + Player\Height/2)
  
  ProcedureReturn Sqr(DX*DX + DY*DY)
  
  CompilerEndIf
EndProcedure
; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 77
; FirstLine = 21
; Folding = De-
; EnableXP