;START:
ProcedureDLL.i GM_GetScene(X.i, Y.i)
  ProcedureReturn GetScene(X, Y)
EndProcedure
ProcedureDLL.i GM_GetWall(X.i, Y.i)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn GetWall(X, Y)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_GetGround(X.i, Y.i)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn GetGround(X, Y)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_GetObject(X.i, Y.i)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn GetObject(X, Y)
  
  CompilerEndIf
EndProcedure

ProcedureDLL.i GM_SceneWidth(*Scene.Scene = #Null)
  CompilerIf #Mode = #Mode_Game
  
  If Not *Scene
    *Scene = Player\Scene
  EndIf
  
  ProcedureReturn *Scene\Width * #SceneWidth
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_SceneHeight(*Scene.Scene = #Null)
  CompilerIf #Mode = #Mode_Game
  
  If Not *Scene
    *Scene = Player\Scene
  EndIf
  
  ProcedureReturn *Scene\Height * #SceneHeight
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_ScenePixelWidth(*Scene.Scene = #Null)
  CompilerIf #Mode = #Mode_Game
  
  If Not *Scene
    *Scene = Player\Scene
  EndIf
  
  ProcedureReturn *Scene\Width * #SceneWidth * #FieldSize
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_ScenePixelHeight(*Scene.Scene = #Null)
  CompilerIf #Mode = #Mode_Game
  
  If Not *Scene
    *Scene = Player\Scene
  EndIf
  
  ProcedureReturn *Scene\Height * #SceneHeight * #FieldSize
  
  CompilerEndIf
EndProcedure

; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 33
; FirstLine = 10
; Folding = 5-
; EnableXP