;START:
ProcedureDLL.i GM_LoadSprite(Name.s)
  ProcedureReturn LoadSprite(#PB_Any, GetFile("Graphics\Objects\" + Name + ".png"), #PB_Sprite_Texture|#PB_Sprite_AlphaBlending|#PB_Sprite_Memory)
EndProcedure
ProcedureDLL.i GM_SpriteWidth(Sprite.i)
  ProcedureReturn SpriteWidth(Sprite)
EndProcedure
ProcedureDLL.i GM_SpriteHeight(Sprite.i)
  ProcedureReturn SpriteHeight(Sprite)
EndProcedure
 
ProcedureDLL.i GM_CreateSprite3D(Sprite.i)
  ProcedureReturn CreateSprite3D(#PB_Any, Sprite)
EndProcedure
ProcedureDLL.i GM_DisplaySprite3D(Sprite3D.i, X.i, Y.i, Transparency.i = 255)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn DisplaySprite3D(Sprite3D, X - Camera\X, Y - Camera\Y, Transparency)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_FreeSprite3D(Sprite3D.i)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn FreeSprite3D(Sprite3D)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_ZoomSprite3D(Sprite3D.i, Width.i, Height.i)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn ZoomSprite3D(Sprite3D, Width, Height)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_RotateSprite3D(Sprite3D.i, Rotation.i)
  CompilerIf #Mode = #Mode_Game
  
  RotateSprite3D(Sprite3D, Rotation, #PB_Absolute)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_EnableBilinearFiltering()
  CompilerIf #Mode = #Mode_Game
  
  Sprite3DQuality(#PB_Sprite3D_BilinearFiltering)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_DisableBilinearFiltering()
  CompilerIf #Mode = #Mode_Game
  
  Sprite3DQuality(#PB_Sprite3D_NoFiltering)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_BlendingMode(Source.i, Destination.i)
  CompilerIf #Mode = #Mode_Game
  
  Sprite3DBlendingMode(Source, Destination)
  
  CompilerEndIf
EndProcedure

ProcedureDLL.i GM_LoadAnimationFrameset(Name.s, FrameWidth.i, FrameHeight.i)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn LoadAnimationFrameset("Objects\" + Name, FrameWidth, FrameHeight)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_CreateAnimation(*Frameset.AnimationFrameset)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn CreateAnimation(*Frameset)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_FramesetFrames(*Frameset.AnimationFrameset)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn *Frameset\FramesPerSet
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_FramesetRows(*Frameset.AnimationFrameset)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn *Frameset\Sets
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_AnimationFrameset(*Animation.Animation)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn *Animation\Frameset
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_FreeAnimation(*Animation.Animation)
  CompilerIf #Mode = #Mode_Game
  
  FreeAnimation(*Animation)
  
  CompilerEndIf
EndProcedure

ProcedureDLL.i GM_DisplayAnimation(*Animation.Animation, X.i, Y.i, Transparency.i = 255)
  CompilerIf #Mode = #Mode_Game
  
  DisplayAnimation(*Animation, X - Camera\X, Y - Camera\Y, Transparency)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_DisplayFramesetFrame(*Frameset.AnimationFrameset, Frame.i, Row.i, X.i, Y.i, Transparency.i = 255)
  CompilerIf #Mode = #Mode_Game
  
  DisplayFramesetFrame(*Frameset, Frame, Row, X - Camera\X, Y - Camera\Y, Transparency)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_FramesetSprite(*Frameset.AnimationFrameset, Frame.i, Row.i)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn FramesetSprite(*Frameset, Frame, Row)
  
  CompilerEndIf
EndProcedure

ProcedureDLL.i GM_SetAnimationFrame(*Animation.Animation, Frame.i)
  CompilerIf #Mode = #Mode_Game
  
  *Animation\Frame = Frame
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_SetAnimationDuration(*Animation.Animation, Duration.i)
  CompilerIf #Mode = #Mode_Game
  
  *Animation\Duration = Duration
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_SetAnimationRow(*Animation.Animation, Row.i)
  CompilerIf #Mode = #Mode_Game
  
  *Animation\Set = Row
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_AnimationFrame(*Animation.Animation)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn *Animation\Frame
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_AnimationRow(*Animation.Animation)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn *Animation\Set
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_PlayAnimation(*Animation.Animation)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn ExamineAnimation(*Animation)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_PlayAnimationBack(*Animation.Animation)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn ExamineAnimationBack(*Animation.Animation)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_SetNextAnimationFrame(*Animation.Animation, Frame.i, Duration.i)
  CompilerIf #Mode = #Mode_Game
  
  *Animation\Frame    = Frame
  *Animation\Duration = Duration
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_AnimationSprite3D(*Animation.Animation)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn PeekI(*Animation\Frameset\Frames + ((*Animation\Set**Animation\Frameset\FramesPerSet) + *Animation\Frame) * 2*_Sz(Integer))
  
  CompilerEndIf
EndProcedure

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 119
; Folding = AAADg
; EnableXP