; PureBasic Visual Designer v3.95 build 1485 (PB4Code)


;- Window Constants
;
Enumeration
  #EditorCPWindow
EndEnumeration

;- Gadget Constants
;
Enumeration
  #EditorCP_OK
  #EditorCP_Panel
  #EditorCP_NameText
  #EditorCP_Name
  #EditorCP_AuthorText
  #EditorCP_Author
  #EditorCP_PasswordText
  #EditorCP_Password
  #EditorCP_CommentFrame
  #EditorCP_Comment
  #EditorCP_AuthorsHighscoreText
  #EditorCP_AuthorsHighscore
  #EditorCP_Play
  #EditorCP_Locked
  #EditorCP_MulFrame
  #EditorCP_MulEnabled
  #EditorCP_MulFFLText
  #EditorCP_MulFFL
  #EditorCP_MulMaxText
  #EditorCP_MulMax
  #EditorCP_PowersFrame
  #EditorCP_CanDoubleJump
  #EditorCP_CanFly1
  #EditorCP_CanShoot1
  #EditorCP_CanShoot2
  #EditorCP_CanShoot3
  #EditorCP_CanClimb
  #EditorCP_LivesText
  #EditorCP_Lives
  #EditorCP_DifficultyText
  #EditorCP_GenreText
  #EditorCP_Genre
  #EditorCP_Difficulty
  #EditorCP_SizeText
  #EditorCP_Size
  #EditorCP_FolderText
  #EditorCP_Folder
  #EditorCP_MaxEnergyText
  #EditorCP_CanFly2
  #EditorCP_CanFly3
  #EditorCP_MaxEnergy
  #EditorCP_EnergyText
  #EditorCP_Energy
  #EditorCP_LibraryText
  #EditorCP_Library
  #EditorCP_SelectLibrary
  #EditorCP_Functions
  #EditorCP_FunctionsText
  #EditorCP_UnuseLibrary
EndEnumeration


Procedure Open_EditorCPWindow()
  If OpenWindow(#EditorCPWindow, 403, 211, 420, 270, "Challange properties",  #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_SizeGadget | #PB_Window_TitleBar )
    If CreateGadgetList(WindowID(#EditorCPWindow))
      ButtonGadget(#EditorCP_OK, 340, 230, 70, 30, "OK")
      ButtonGadget(#EditorCP_Play, 340, 200, 70, 30, "Play")
      CheckBoxGadget(#EditorCP_Locked, 340, 10, 70, 20, "Locked")
      
      ;- Panel
      PanelGadget(#EditorCP_Panel, 10, 10, 320, 250)
      AddGadgetItem(#EditorCP_Panel, -1, "General")
      TextGadget(#EditorCP_NameText, 8, 40, 40, 16, "Name:")
      StringGadget(#EditorCP_Name, 68, 38, 240, 20, "")
      TextGadget(#EditorCP_AuthorText, 8, 70, 40, 16, "Author:")
      StringGadget(#EditorCP_Author, 68, 68, 240, 20, "")
      TextGadget(#EditorCP_PasswordText, 8, 100, 50, 16, "Password:")
      StringGadget(#EditorCP_Password, 68, 98, 240, 20, "", #PB_String_Password)
      Frame3DGadget(#EditorCP_CommentFrame, 8, 118, 300, 100, "Comment")
      EditorGadget(#EditorCP_Comment, 18, 138, 280, 70)
      TextGadget(#EditorCP_FolderText, 8, 10, 50, 16, "Folder:")
      ComboBoxGadget(#EditorCP_Folder, 68, 8, 240, 20)
      AddGadgetItem(#EditorCP_Panel, -1, "Score")
      TextGadget(#EditorCP_AuthorsHighscoreText, 8, 10, 100, 16, "Author's highscore:")
      StringGadget(#EditorCP_AuthorsHighscore, 108, 8, 200, 20, "", #PB_String_ReadOnly)
      Frame3DGadget(#EditorCP_MulFrame, 8, 38, 300, 80, "Multiplier")
      CheckBoxGadget(#EditorCP_MulEnabled, 18, 58, 60, 20, "Enabled")
      TextGadget(#EditorCP_MulFFLText, 88, 60, 90, 16, "Frames for lapsing:")
      StringGadget(#EditorCP_MulFFL, 178, 58, 120, 20, "", #PB_String_Numeric)
      TextGadget(#EditorCP_MulMaxText, 88, 90, 90, 16, "Maximum:")
      StringGadget(#EditorCP_MulMax, 178, 88, 120, 20, "", #PB_String_Numeric)
      AddGadgetItem(#EditorCP_Panel, -1, "Player")
      Frame3DGadget(#EditorCP_PowersFrame, 8, 68, 300, 90, "Powers")
      CheckBoxGadget(#EditorCP_CanDoubleJump, 18, 88, 80, 20, "Double Jump")
      CheckBoxGadget(#EditorCP_CanFly1, 118, 88, 80, 20, "Fly I")
      CheckBoxGadget(#EditorCP_CanShoot1, 218, 88, 80, 20, "Shoot I")
      CheckBoxGadget(#EditorCP_CanShoot2, 218, 108, 80, 20, "Shoot II")
      CheckBoxGadget(#EditorCP_CanShoot3, 218, 128, 80, 20, "Shoot III")
      CheckBoxGadget(#EditorCP_CanClimb, 18, 108, 90, 20, "Climb")
      TextGadget(#EditorCP_LivesText, 8, 10, 40, 16, "Lives:")
      StringGadget(#EditorCP_Lives, 78, 8, 70, 20, "", #PB_String_Numeric)
      TextGadget(#EditorCP_MaxEnergyText, 8, 40, 70, 16, "Max. Energy:")
      CheckBoxGadget(#EditorCP_CanFly2, 118, 108, 60, 20, "Fly II")
      CheckBoxGadget(#EditorCP_CanFly3, 118, 128, 70, 20, "Fly III")
      StringGadget(#EditorCP_MaxEnergy, 78, 38, 70, 20, "", #PB_String_Numeric)
      TextGadget(#EditorCP_EnergyText, 168, 40, 70, 16, "Energy:")
      StringGadget(#EditorCP_Energy, 238, 38, 70, 20, "", #PB_String_Numeric)
      AddGadgetItem(#EditorCP_Panel, -1, "Categories")
      TextGadget(#EditorCP_DifficultyText, 8, 40, 50, 16, "Difficulty:")
      TextGadget(#EditorCP_GenreText, 8, 10, 40, 16, "Genre:")
      ComboBoxGadget(#EditorCP_Genre, 78, 8, 230, 20)
      ComboBoxGadget(#EditorCP_Difficulty, 78, 38, 230, 20)
      TextGadget(#EditorCP_SizeText, 8, 70, 60, 16, "Size:")
      ComboBoxGadget(#EditorCP_Size, 78, 68, 230, 20)
      AddGadgetItem(#EditorCP_Panel, -1, "Script")
      TextGadget(#EditorCP_LibraryText, 8, 10, 40, 16, "Library:")
      StringGadget(#EditorCP_Library, 48, 8, 200, 20, "")
      ButtonGadget(#EditorCP_SelectLibrary, 248, 8, 40, 20, "...")
      ListViewGadget(#EditorCP_Functions, 8, 58, 300, 160)
      TextGadget(#EditorCP_FunctionsText, 8, 40, 50, 16, "Functions:")
      ButtonGadget(#EditorCP_UnuseLibrary, 288, 8, 20, 20, "X")
      CloseGadgetList()
      
    EndIf
  EndIf
EndProcedure

