Procedure.i DisplayBottomSignal()
  Protected Index.i
  
  If PlayerNeighbourScene(0, 1) Or Player\Scene\VerticalLoop
    For Index = 0 To #SceneWidth - 1
      DisplaySprite3D(GreenBottom\Sprite3D, Index * #FieldSize, #SceneHeight * #FieldSize - 10)
    Next
  Else
    For Index = 0 To #SceneWidth - 1
      DisplaySprite3D(RedBottom\Sprite3D, Index * #FieldSize, #SceneHeight * #FieldSize - 10)
    Next
  EndIf
EndProcedure



Procedure.i Pause()
  Protected Event.i
  
  ClearScreen(#Black)
  
  StartDrawing(ScreenOutput())
    DrawingMode(#PB_2DDrawing_Transparent)
    DrawText(#ScreenWidth / 2 - TextWidth("P A U S E") / 2 + 2, #ScreenHeight / 2 + 2, "P A U S E", $FF0000, $000000)
    DrawText(#ScreenWidth / 2 - TextWidth("P A U S E") / 2, #ScreenHeight / 2, "P A U S E", $FFFFFF, $000000)
  StopDrawing()
  
  FlipBuffers()
  
  Repeat
    Event = WindowEvent()
    
    OptimizeFPS(15)
  Until KeyPressedDown(#VK_P)
EndProcedure
Procedure.i Play()
  Protected Event.i
  
  ResetCamera()
  Repeat
    Event = WindowEvent()
    
    ExaminePlayer()
    If Quit
      Break
    EndIf
    
    If Player\LostLiveTime = 1 And Player\Lives > 0
      ; Weien Hintergrund einblenden:
      ClearScreen(#White)
      FlipBuffers()
      
      Delay(400)
    Else
      ExamineCamera()
      ExamineParticles()
      
      StartSpecialFX()
        DisplayBackground(Player\Scene\Background)
        
        Start3D()
          PlayAndDisplayScene()
          If IsKeyPressing(#VK_NEXT)
            DisplayBottomSignal()
          EndIf
        Stop3D()
      StopSpecialFX()
      
      DrawHUD()
      
      FlipBuffers()
      
      If KeyPressedDown(#VK_F11)
        OpenScreenshotMode()
      ElseIf KeyPressedDown(#VK_P)
        Pause()
      EndIf
    EndIf
    
    OptimizeFPS(15)
  Until Event = #PB_Event_CloseWindow Or KeyPressedDown(#VK_ESCAPE) Or Quit
EndProcedure
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 22
; FirstLine = 6
; Folding = -
; EnableXP