Structure ScreenButton
  X.i
  Y.i
  Sprite.i
  Visible.i
EndStructure


Procedure.i ExamineScreenButtons(Array Button.ScreenButton(1))
  Protected Size.i = ArraySize(Button()), Index.i
  
  For Index = 0 To Size
    If Button(Index)\Visible And MouseOverScreenButton(@Button(Index)) And Window_Event = #WM_LBUTTONDOWN
      ProcedureReturn @Button(Index)
    EndIf
  Next
  
  ProcedureReturn #Null
EndProcedure
Procedure.i InitScreenButton(*Button.ScreenButton, X.i, Y.i, Sprite.i, Visible.i = #True)
  Protected *Button.ScreenButton
  
  *Button\X       = X
  *Button\Y       = Y
  *Button\Sprite  = Sprite
  *Button\Visible = Visible
  
  ProcedureReturn *Button
EndProcedure
Procedure.i DisplayScreenButtons(Array Button.ScreenButton(1))
  Protected Size.i = ArraySize(Button()), Index.i, *Over.ScreenButton
  Static OverEffect.f
  
  For Index = 0 To Size
    If Button()\Visible
      DisplaySprite(Button(Index)\Sprite, Button(Index)\X, Button(Index)\Y)
    EndIf
  Next
  
  ProcedureReturn *Over
EndProcedure
Procedure.i MouseOverScreenButton(*Button.ScreenButton)
  Protected X.i, Y.i
  
  If X => *Button\X And X < *Button\X + SpriteWidth(*Button\Sprite) And Y => *Button\Y And Y < *Button\Y + SpriteHeight(*Button\Sprite)
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure
; IDE Options = PureBasic 4.41 (Windows - x86)
; CursorPosition = 12
; Folding = -
; EnableXP