Procedure.i CoinTemplate(*Object.GM_Object, Event.i, *Parameter, *CoinParameter.CoinParameter)
  Select Event
    Case #GM_Object_Display
      If *Object\Memory
        If *Object\Memory < 20
          If *Object\Memory % 7 < 4
            GM_DisplayAnimation(*Object\Animation, *Object\X - #CoinOuterRadius, *Object\Y - #CoinOuterRadius, *Object\Transparency)
          Else
            GM_DisplayFramesetFrame(CollectedCoinFrameset, GM_AnimationFrame(*Object\Animation), 0, *Object\X - #CoinOuterRadius, *Object\Y - #CoinOuterRadius, *Object\Transparency)
          EndIf
        EndIf
      Else
        GM_DisplayAnimation(*Object\Animation, *Object\X - #CoinOuterRadius, *Object\Y - #CoinOuterRadius, *Object\Transparency)
      EndIf
    Case #GM_Object_Frame
      If *Object\Memory
        If *Object\Memory < 20
          ; Mnze ausblenden und nach oben fliegen lassen (wenn gesammelt):
          *Object\Transparency = 255 - (Pow(Pow(255, 1.0/20), *Object\Memory) - 1)
          *Object\Y - 2.5
          
          *Object\Memory + 1
          
          ; Animation abspielen lassen:
          If GM_PlayAnimation(*Object\Animation)
            ; Es wurde auf ein neues Frame gewechselt:
            GM_SetAnimationDuration(*Object\Animation, 0) ;Dauer fr den neuen Frame festlegen
          EndIf
        Else
          ; Mnze entgltig aus dem Spiel entfernen:
          ProcedureReturn #GM_Object_DoDelete
        EndIf
      Else
        ; Animation abspielen lassen:
        If GM_PlayAnimation(*Object\Animation)
          ; Es wurde auf ein neues Frame gewechselt (Duration = 0):
          GM_SetAnimationDuration(*Object\Animation, #CoinRotationSpeed) ;Dauer fr den neuen Frame festlegen
        EndIf
      EndIf
    Case #GM_Object_Collision
      If Not *Object\Memory ;Noch nicht gesammelt?
        ; Mnze wurde gesammelt:
        If *CoinParameter\Value <> -1
          GM_AddCoin()
          GM_AddScoreTM(*CoinParameter\Value, *Object) ;Punkte geben
        Else
          GM_AddSuperCoin()
          GM_AddScoreNMTM(1000, *Object) ;Pukte ohne Multiplikator geben
        EndIf
        
        *Object\Memory = 1 ;Auf "gesammelt" setzen
      EndIf
    Case #GM_Object_Delete
      GM_FreeAnimation(*Object\Animation)
    
    Case #GM_Object_Initialize
      ; Passend verschieben:
      *Object\X      + #CoinOuterRadius
      *Object\Y      + #CoinOuterRadius
      ; Breite und Hhe an die Mae einer Mnze anpassen:
      *Object\Width  = #CoinRadius*2
      *Object\Height = #CoinRadius*2
      
      *Object\Animation = GM_CreateAnimation(Coin_Frameset(*CoinParameter\Index))
      GM_SetNextAnimationFrame(*Object\Animation, Random(3), Random(#CoinRotationSpeed))
    Case #GM_Object_Load
      ; Position der Mnze laden:
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
      If *CoinParameter\Index = 5
        GM_CountSuperCoin()
      Else
        GM_CountCoin()
      EndIf
    Case #GM_Object_GlobalLoad
      ; Frameset laden (Frames fr eine Animation)
      LoadCoin(*CoinParameter\Index)
      
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
      
    Case #GM_Object_ViewSprite
      ; Name des Anzeige-Sprites fr den Editor zurckgeben:
      ReturnString("Coin\Coin" + Str(*CoinParameter\Index + 1))
    Case #GM_Object_ViewRegion
      ReturnViewRegion(0, 0, 1, 1)
    Case #GM_Object_PreferedLayer
      ; Bevorzugter Layer:
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      ; berprfen, ob der gewhlte Layer geeignet ist:
      If *Parameter = #GM_Layer_StaticObject
        ; Nicht geeignet:
        ProcedureReturn #False
      Else
        ; Geeignet:
        ProcedureReturn #True
      EndIf
    Case #GM_Object_Name
      ; Name des Objekts zurckgeben:
      ProcedureReturn @*CoinParameter\Name
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

ProcedureDLL.i Obj_Coin1(*Object.GM_Object, Event.i, *Parameter)
  Global Coin1.CoinParameter
  
  With Coin1
    If Not \Initialised
      \Index       = 0
      \Value       = 5
      \Name        = "Yellow Coin (" + Str(\Value) + "P)"
      \Initialised = #True
    EndIf
  EndWith
  
  ProcedureReturn CoinTemplate(*Object, Event, *Parameter, @Coin1)
EndProcedure
ProcedureDLL.i Obj_Coin2(*Object.GM_Object, Event.i, *Parameter)
  Global Coin2.CoinParameter
  
  With Coin2
    If Not \Initialised
      \Index       = 1
      \Value       = 10
      \Name        = "Orange Coin (" + Str(\Value) + "P)"
      \Initialised = #True
    EndIf
  EndWith
  
  ProcedureReturn CoinTemplate(*Object, Event, *Parameter, @Coin2)
EndProcedure
ProcedureDLL.i Obj_Coin3(*Object.GM_Object, Event.i, *Parameter)
  Global Coin3.CoinParameter
  
  With Coin3
    If Not \Initialised
      \Index       = 2
      \Value       = 15
      \Name        = "Red Coin (" + Str(\Value) + "P)"
      \Initialised = #True
    EndIf
  EndWith
  
  ProcedureReturn CoinTemplate(*Object, Event, *Parameter, @Coin3)
EndProcedure
ProcedureDLL.i Obj_Coin4(*Object.GM_Object, Event.i, *Parameter)
  Global Coin4.CoinParameter
  
  With Coin4
    If Not \Initialised
      \Index       = 3
      \Value       = 50
      \Name        = "Magenta Coin (" + Str(\Value) + "P)"
      \Initialised = #True
    EndIf
  EndWith
  
  ProcedureReturn CoinTemplate(*Object, Event, *Parameter, @Coin4)
EndProcedure
ProcedureDLL.i Obj_Coin5(*Object.GM_Object, Event.i, *Parameter)
  Global Coin5.CoinParameter
  
  With Coin5
    If Not \Initialised
      \Index       = 4
      \Value       = 100
      \Name        = "Blue Coin (" + Str(\Value) + "P)"
      \Initialised = #True
    EndIf
  EndWith
  
  ProcedureReturn CoinTemplate(*Object, Event, *Parameter, @Coin5)
EndProcedure
ProcedureDLL.i Obj_Coin6(*Object.GM_Object, Event.i, *Parameter)
  Global Coin6.CoinParameter
  
  With Coin6
    If Not \Initialised
      \Index       = 5
      \Value       = -1
      \Name        = "Cyan Coin (super coin)"
      \Initialised = #True
    EndIf
  EndWith
  
  ProcedureReturn CoinTemplate(*Object, Event, *Parameter, @Coin6)
EndProcedure

; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 44
; FirstLine = 24
; Folding = B+
; EnableXP