#HGroundSpeed = 0.75

Global HGround1_Sprite.i, HGround1_Sprite3D.i

ProcedureDLL.i Obj_HGround1(*Object.GM_Object, Event.i, *Parameter)
  Select Event
    Case #GM_Object_Display
      GM_DisplaySprite3D(HGround1_Sprite3D, *Object\X, *Object\Y, *Object\Transparency)
    Case #GM_Object_Frame
      *Object\X + *Object\Memory * #HGroundSpeed
      If GM_FieldCollision(*Object, *Object\Memory * #HGroundSpeed, 0, *Object\Memory, 0)
        *Object\Memory = -*Object\Memory
      EndIf
    Case #GM_Object_Collision
      If GM_DoGroundCollision(*Object, GM_PlayerGroundCollision(*Object, *Object\Memory * #HGroundSpeed, 0))
        GM_StickPlayerOn(*Object)
      EndIf
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      HGround1_Sprite   = GM_LoadSprite("Platforms\Ground1")
      HGround1_Sprite3D = GM_CreateSprite3D(HGround1_Sprite)
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
      *Object\Memory = 1
      
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_StaticObject
        ProcedureReturn #False
      Else
        ProcedureReturn #True
      EndIf
      
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Platforms\Ground1"
    Case #GM_Object_Name
      ProcedureReturn @"Small Ground (H)"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_HGround2(*Object.GM_Object, Event.i, *Parameter)
  Global HGround2_Sprite.i, HGround2_Sprite3D.i
  Protected *EditorObject.GM_EditorObject
  
  Select Event
    Case #GM_Object_Display
      GM_DisplaySprite3D(HGround2_Sprite3D, *Object\X, *Object\Y, *Object\Transparency)
    Case #GM_Object_Frame
      *Object\X + *Object\Memory * #HGroundSpeed
      If GM_FieldCollision(*Object, *Object\Memory * #HGroundSpeed, 0, *Object\Memory, 0)
        *Object\Memory = -*Object\Memory
      EndIf
    Case #GM_Object_Collision
      If GM_DoGroundCollision(*Object, GM_PlayerGroundCollision(*Object, *Object\Memory * #HGroundSpeed, 0))
        GM_StickPlayerOn(*Object)
      EndIf
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      HGround2_Sprite   = GM_LoadSprite("Platforms\Ground2")
      HGround2_Sprite3D = GM_CreateSprite3D(HGround2_Sprite)
    Case #GM_Object_Initialize
      *Object\Width  = 2 * #GM_FieldSize
      *Object\Height = #GM_FieldSize
      *Object\Memory = 1
      
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_StaticObject
        ProcedureReturn #False
      Else
        ProcedureReturn #True
      EndIf
      
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Platforms\Ground2"
    Case #GM_Object_ViewRegion
      ViewRegion\X      = 0
      ViewRegion\Y      = 0
      ViewRegion\Width  = #GM_FieldSize * 2
      ViewRegion\Height = #GM_FieldSize
      ProcedureReturn @ViewRegion
    Case #GM_Object_Name
      ProcedureReturn @"Medium Ground (H)"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 107
; Folding = -
; EnableXP