;**************************************************************
;     System
;**************************************************************
;   Copyright (c) 2010 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



IncludeFile "..\Import.pbi"



EnableExplicit



ProcedureDLL.i GM_Build()
  DataSection
    Entries:
      GM_Folder("System")
        GM_Folder("Walls & Grounds")
          GM_File("IWall")
          GM_File("SkewL")
          GM_File("SkewR")
          GM_End()
        GM_Folder("Traps")
          GM_File("TrapF")
          GM_File("TrapT")
          GM_File("TrapB")
          GM_File("TrapL")
          GM_File("TrapR")
          GM_End()
        GM_Folder("Warping")
          GM_File("Teleporter")
          GM_End()
        GM_Folder("Wind")
          GM_File("WindR")
          GM_File("WindL")
          GM_File("WindU")
          GM_File("WindD")
          GM_End()
        GM_Folder("Targets & Triggers")
          GM_File("Check")
          GM_File("Genstar")
          GM_File("Killstar")
          GM_File("Target")
          GM_End()
        GM_File("Ladder")
        GM_File("Msg")
        GM_File("SpringBoard")
        GM_File("JumpSupporter")
        GM_File("NoClimb")
        GM_End()
      GM_End()
  EndDataSection
  
  ProcedureReturn ?Entries
EndProcedure



IncludeFile "System\Fields.pb"
IncludeFile "System\Traps.pb"
IncludeFile "System\Checkpoint.pb"
IncludeFile "System\Teleporter.pb"
IncludeFile "System\Stars.pb"
IncludeFile "System\Wind.pb"
IncludeFile "System\Target.pb"
IncludeFile "System\JumpSupporter.pb"
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 63
; FirstLine = 23
; Folding = -
; EnableXP