Global Target_Frameset.i, Target_LightSprite.i, Target_LightSprite3D.i

#Target_ArrowWidth = 14

ProcedureDLL.i Obj_Target(*Object.GM_Object, Event.i, *Parameter)
  Select Event
    Case #GM_Object_Display
      If *Object\Memory = 0
        GM_DisplayAnimation(*Object\Animation, *Object\X + *Object\Width/2 - #Target_ArrowWidth/2, *Object\Y - 11)
        GM_BlendingMode(5, 2)
        GM_DisplaySprite3D(Target_LightSprite3D, *Object\X - 5, *Object\Y)
        GM_BlendingMode(5, 6)
      Else
        If *Object\Memory % 7 < 4
          GM_DisplayAnimation(*Object\Animation, *Object\X + *Object\Width/2 - #Target_ArrowWidth/2, *Object\Y - 11 - *Object\Memory * 2.5, 255.0/20 * (20 - *Object\Memory))
        Else
          GM_DisplayAnimation(*Object\Animation, *Object\X + *Object\Width/2 - #Target_ArrowWidth/2, *Object\Y - 11 - *Object\Memory * 2.5)
        EndIf
        GM_BlendingMode(5, 2)
        GM_DisplaySprite3D(Target_LightSprite3D, *Object\X - 5, *Object\Y, 255.0/20 * (20 - *Object\Memory))
        GM_BlendingMode(5, 6)
      EndIf
    Case #GM_Object_Frame
      If *Object\Memory = 0
        If GM_PlayAnimation(*Object\Animation)
          GM_SetAnimationDuration(*Object\Animation, 5)
        EndIf
      Else
        If GM_PlayAnimation(*Object\Animation)
          GM_SetAnimationDuration(*Object\Animation, 0)
        EndIf
        If *Object\Memory % 7 < 4
          GM_SetAnimationRow(*Object\Animation, 0)
        Else
          GM_SetAnimationRow(*Object\Animation, 1)
        EndIf
        
        *Object\Memory + 1
        If *Object\Memory = 20
          ProcedureReturn #GM_Object_DoDelete
        EndIf
      EndIf
    Case #GM_Object_Collision
      If *Object\Memory = 0
        *Object\Memory = 1
        GM_EmitAirExplosion(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2)
      EndIf
    
    Case #GM_Object_Initialize
      *Object\X      + 5
      *Object\Y      + #GM_FieldSize
      *Object\Width  = #GM_FieldSize - 10
      *Object\Height = #GM_FieldSize
      
      *Object\Animation = GM_CreateAnimation(Target_Frameset)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not Target_Frameset
        Target_Frameset      = GM_LoadAnimationFrameset("System\TargetArrow", 14, 16)
        Target_LightSprite   = GM_LoadSprite("System\TargetLight")
        Target_LightSprite3D = GM_CreateSprite3D(Target_LightSprite)
      EndIf
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_ForegroundObject1
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @"System\Target-View"
    Case #GM_Object_Name
      ProcedureReturn @"Target Point"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 45
; FirstLine = 18
; Folding = -
; EnableXP