Procedure.i TrapTemplate(*Object.GM_Object, Event.i, *Parameter, X.i, Y.i, Width.i, Height.i, Suffix.c)
  Select Event
    Case #GM_Object_Collision
      GM_LoseLife()
      
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_Initialize
      *Object\X      + X
      *Object\Y      + Y
      *Object\Width  = Width
      *Object\Height = Height
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      ProcedureReturn #True
    
    Case #GM_Object_ViewSprite
      String = "System\Trap" + Chr(Suffix)
      ProcedureReturn @String
    Case #GM_Object_Name
      String = "Trap ("
      Select Suffix
        Case 'T' : String + "top"
        Case 'B' : String + "bottom"
        Case 'L' : String + "left"
        Case 'R' : String + "right"
        Case 'F' : String + "full"
      EndSelect
      String + ")"
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_TrapF(*Object.GM_Object, Event.i, *Parameter)
  ProcedureReturn TrapTemplate(*Object, Event, *Parameter, 0, 0, #GM_FieldSize, #GM_FieldSize, 'F')
EndProcedure
ProcedureDLL.i Obj_TrapT(*Object.GM_Object, Event.i, *Parameter)
  ProcedureReturn TrapTemplate(*Object, Event, *Parameter, 0, 0, #GM_FieldSize, 4, 'T')
EndProcedure
ProcedureDLL.i Obj_TrapB(*Object.GM_Object, Event.i, *Parameter)
  ProcedureReturn TrapTemplate(*Object, Event, *Parameter, 0, #GM_FieldSize - 4, #GM_FieldSize, 4, 'B')
EndProcedure
ProcedureDLL.i Obj_TrapL(*Object.GM_Object, Event.i, *Parameter)
  ProcedureReturn TrapTemplate(*Object, Event, *Parameter, 0, 0, 4, #GM_FieldSize, 'L')
EndProcedure
ProcedureDLL.i Obj_TrapR(*Object.GM_Object, Event.i, *Parameter)
  ProcedureReturn TrapTemplate(*Object, Event, *Parameter, #GM_FieldSize - 4, 0, 4, #GM_FieldSize, 'R')
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 57
; FirstLine = 13
; Folding = --
; EnableXP