Procedure.i CreateBallActor(*Object.GM_Object, Speed.f, StartAngle.f)
  Static *Actor.BallActor
  
  *Actor = AllocateMemory(SizeOf(BallActor))
  
  *Actor\Object = *Object
  
  *Actor\Speed = Speed
  *Actor\Angle = StartAngle
  
  ProcedureReturn *Actor
EndProcedure
Procedure.i BallActorCollision(*Actor.BallActor, Collision.i)
  Select Collision
    Case #GM_Collision_Top
      *Actor\Angle = 180 - *Actor\Angle
    Case #GM_Collision_Right
      *Actor\Angle = 360 - *Actor\Angle
  EndSelect
EndProcedure
Procedure.f BallActorMotionX(*Actor.BallActor)
  ProcedureReturn Cos(*Actor\Angle) * *Actor\Speed
EndProcedure
Procedure.f BallActorMotionY(*Actor.BallActor)
  ProcedureReturn Sin(*Actor\Angle) * *Actor\Speed
EndProcedure
Procedure.f RotateBallActor(*Actor.BallActor, Angle.f)
  *Actor\Angle + Angle
  If *Actor\Angle > 2 * #PI
    *Actor\Angle - 2 * #PI
  ElseIf *Actor\Angle < -2 * #PI
    *Actor\Angle + 2 * #PI
  EndIf
  
  ProcedureReturn *Actor\Angle
EndProcedure
Procedure.i FreeBallActor(*Actor.BallActor)
  ProcedureReturn FreeMemory(*Actor)
EndProcedure
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 14
; Folding = --
; EnableXP