Structure EmitterParameter
  Name.s
  File.s
  MinDuration.i
  AdditionalDuration.i
  *EmitCallback
  Description.s
  
  Initialized.i
EndStructure

Procedure.i EmitterTemplate(*Object.GM_Object, Event.i, *Parameter, *EmitterParameter.EmitterParameter)
  Select Event
    Case #GM_Object_Frame
      If *Object\Memory = 0
        *Object\Memory = *EmitterParameter\MinDuration + Random(*EmitterParameter\AdditionalDuration)
        CallFunctionFast(*EmitterParameter\EmitCallback, *Object)
      Else
        *Object\Memory - 1
      EndIf
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_Initialize
      *Object\Memory = Random(*EmitterParameter\MinDuration + *EmitterParameter\AdditionalDuration)
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject2
    Case #GM_Object_CheckLayer
      ProcedureReturn #True
    Case #GM_Object_ViewSprite
      ProcedureReturn @*EmitterParameter\File
    Case #GM_Object_Name
      ProcedureReturn @*EmitterParameter\Name
    Case #GM_Object_Description
      If *EmitterParameter\Description
        ProcedureReturn @*EmitterParameter\Description
      EndIf
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
Procedure.i EmitterTime(*Object.GM_Object)
  ProcedureReturn *Object\Memory
EndProcedure
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 17
; Folding = -
; EnableXP